#include <stdio.h>
#include <usb.h>
struct usb_device * phone;
usb_dev_handle * phoneHandle;

void cmd_parse(int argc, char ** args);
void u_init()
{   
	usb_init();
	usb_find_busses();
	usb_find_devices();
}   

struct usb_device * u_finddev(int vendor, int product)
{   
	struct usb_bus *busses;
	struct usb_bus *bus;

	usb_find_busses();
	usb_find_devices();

	busses = usb_get_busses();
	for (bus = busses; bus; bus = bus->next)
	{   
		struct usb_device *dev;

		for (dev = bus->devices; dev; dev = dev->next)
			if ((dev->descriptor.idVendor==vendor) && (dev->descriptor.idProduct==product))
				return(dev);

	}
	return(0x00);
}   
int u_connect()
{

	phoneHandle=0;

	phoneHandle = usb_open(phone);
	if (phoneHandle==0) {
		fprintf (stderr,usb_strerror());
		return -1;
	}
  if (usb_set_configuration(phoneHandle,1)){
	  fprintf(stderr,"Unable to set configuration\n");
	  return -1;
  }
   if (usb_claim_interface(phoneHandle, 0)){
	  fprintf(stderr,"Unable to claim\n");
	  return -1;
  }
//;   usb_resetep(phoneHandle, 1);

//  //  if (usb_claim_interface(phoneHandle, INTERFACE_TEST_COMMAND)) RAISE(P2K_E_CANT_CLAIMIFACE, "Unable to claim the interface");
	return(0);
}

int send_packet(unsigned char * cmd, unsigned char * data, unsigned long sdata){
//	fprintf(stderr,"ho\n");
	long len=strlen(cmd)+sdata+3;
	unsigned char * buf=malloc(len);
	unsigned char * cbuf=buf;
	int t;
	cbuf[0]=2;
	cbuf++;
	for(;*cmd;cmd++,cbuf++){
		*cbuf=*cmd;
	}
	*cbuf=0x1E;
	cbuf++;
//	fprintf(stderr, "%s",buf);
	for(t=0;t<sdata;t++,cbuf++){
		*cbuf=data[t];
	}
	*cbuf=3;
	
//	fwrite(buf,1,len,stderr);
	long ret;
	cbuf=buf;
	for(;len>0;len-=ret){
		ret=usb_bulk_write(phoneHandle,1,cbuf,len,1000);
//		fprintf(stderr,"len=%i,ret=%i\n",len,ret);
		if(ret<0 && ret!=-110){
			fprintf (stderr,"error: %s\n",usb_strerror());	
			exit(-1);
		}
		cbuf+=ret;
	}
	free (buf);
//;	fprintf("")
}

void cmd_addr(unsigned long addr){
	fprintf(stderr,"cmd addr 0x%08x\n",addr);
	unsigned char str[11];
	sprintf(&str[0],"%08X",addr);
	int t;unsigned char sum=0;
	for(t=0;t<8;t++)
		sum+=str[t];
	sprintf(&str[8], "%02X",sum);
	send_packet("ADDR",str,10);
}

void cmd_jump(unsigned long addr){
	fprintf(stderr,"cmd jump 0x%08x\n",addr);
	unsigned char str[11];
	sprintf(&str[0],"%08X",addr);
	int t;unsigned char sum=0;
	for(t=0;t<8;t++)
		sum+=str[t];
	sprintf(&str[8], "%02X",sum);
	send_packet("JUMP",str,10);
}

void cmd_dump(unsigned long addr){
	unsigned char str[11];
	sprintf(&str[0],"%08X",addr);
	int t;unsigned char sum=0;
	for(t=0;t<8;t++)
		sum+=str[t];
	sprintf(&str[8], "%02X",sum);
	send_packet("DUMP",str,10);
}

void cmd_bin(unsigned char * buf, long sbuf){
	fprintf(stderr,"cmd bin size=%i\n",sbuf);
	unsigned char * mbuf=malloc(sbuf+3);
	mbuf[0]=(sbuf>>8)&0xff;
	mbuf[1]=sbuf&0xff;
	memcpy(&mbuf[2],buf,sbuf);
	int t;unsigned char sum=0;
	for(t=0;t<sbuf;t++)
		sum+=mbuf[2+t];
	mbuf[2+sbuf]=sum;
	send_packet("BIN",mbuf,sbuf+3);
	free(mbuf);
}

int u_read_lim(char * buf, int max)
{
	int cnt=0;
	int ret;
	do {
		ret=usb_bulk_read(phoneHandle,2,buf+cnt,max-cnt,1000);
		if (ret<0 && ret!=-110) return ret;
		if (ret>0) cnt+=ret;
	} while (ret!=-110 && cnt==0);
	return cnt;
};

int u_read_exact(char * buf, int len)
{
	int cnt=0;
	do {
		int ret=u_read_lim(buf+cnt,len-cnt);
		if (ret<0) return ret;
		else cnt+=ret;
	} while (cnt<len);
	return cnt;
}

void ack(){
	char buf[256]={0};		
	int ret=u_read_lim(buf,255);
	if(ret<0){
		fprintf(stderr,"%s:usb error code %i \"%s\" \n",__FUNCTION__,ret,usb_strerror());
		return;
	}
	else{
		buf[ret] = 0;
		fprintf(stderr,"%s\n",buf);
		return;
	}
}

void ack_buf(char * buf){
	int cnt = 0;
	int ret=u_read_lim(buf,256);
	if(ret<0){
		fprintf(stderr,"%s:usb error code %i \"%s\" \n",__FUNCTION__,ret,usb_strerror());
		return;
	}
	else{
		cnt+=ret;
	}
	return;
}

void cmd_loadfile(char * filename, unsigned long addr){
	FILE * fil=fopen(filename,"rb");
	if(!fil){
		fprintf(stderr,"%s:file \"%s\" not found\n",__FUNCTION__,filename);
		return ;
	}
//	long filesize;
	char * buf=malloc(0x800);
	
//	fseek(fil,0,SEEK_END);
//	filesize=ftell(fil);
//	fseek(fil,0,SEEK_SET);
	unsigned long t;	
	int ret=0x800;
	for(t=0;ret==0x800;t+=0x800){
		ret=fread(buf,1,0x800,fil);
		cmd_addr(t+addr);
		ack();
		cmd_bin(buf,ret);
		ack();
	}
	free(buf);
	fclose(fil);
}

void cmd_dumpfile(char * filename, unsigned long beg_addr,unsigned long end_addr){
	FILE * fil=fopen(filename,"wb");
	if(!fil){
		fprintf(stderr,"%s:file \"%s\" not found\n",__FUNCTION__,filename);
		return ;
	}
	char * buf=malloc(0x100);
	
	unsigned long t;	
	
	for(;end_addr-beg_addr>=0x100;beg_addr+=0x100){
		cmd_dump(beg_addr);
		ack_buf(buf);
		fwrite(buf,1,end_addr-beg_addr>=0x100?0x100:end_addr-beg_addr,fil);
	}
	free(buf);
	fclose(fil);
}

void cmd_any(char * cmd, char * arg){
	fprintf(stderr,"%s %s\n",cmd,arg);
	send_packet(cmd,arg,arg?strlen(arg):0);
}

void u_disconnect(){
	usb_release_interface(phoneHandle, 0);
	usb_close(phoneHandle);
	usb_free_dev(phone);
}

void script_parse(char * filename){
	FILE * fil;
	if(filename){
		fil=fopen(filename,"rb");
		if(!fil){
			fprintf(stderr,"%s: file \"%s\" not found\n",__FUNCTION__,filename);
			return;
		}
	}else
		fil=stdin;
	int t;
	char * args[10];
	int argc=0;
	char buf[2048];
	char * st;
	int len;
	while(1){
		argc=0;
		if(!fgets(buf,2047,fil))
			break;
		len=strlen(buf);
		st=strchr(buf,'#');
		if(st){
			*st=0;
			len=st-&buf[0];
		}
		
		for(t=0;t<len;t++){
			if(buf[t]==0x20 || buf[t]=='\t' || buf[t]=='\n'){
				buf[t]=0;
			}
		}
		fprintf(stderr,"\n");
		for(t=0;t<len;t++){
			if(!buf[t])
				continue;
			fprintf(stderr,"%s ",&buf[t]);
			args[argc]=&buf[t];
			argc++;
			if(argc==10)
				break;
			t+=strlen(&buf[t]);
		}
		fprintf(stderr,"\n");
		if(argc<10)
			args[argc]=0;
		
		if(argc>0)
			cmd_parse(argc,&args[0]);	

	}
	if(filename)
		fclose(fil);
}

void cmd_parse(int argc, char ** args)
{
	unsigned long addr,addr2;
	if(!strcmp(args[0],"addr")){
		sscanf(args[1],"%08X",&addr);
		cmd_addr(addr);
	}else if(!strcmp(args[0],"jump")){
		sscanf(args[1],"%08X",&addr);
		cmd_jump(addr);
	}else if(!strcmp(args[0],"ack")){
		ack();
	}else if(!strcmp(args[0],"dumpfile")){
		
		sscanf(args[2],"%08X",&addr);
		sscanf(args[3],"%08X",&addr2);
		cmd_dumpfile(args[1],addr,addr2);
	}else if(!strcmp(args[0],"loadfile")){
		
		sscanf(args[2],"%08X",&addr);
		cmd_loadfile(args[1],addr);
	}else{
		cmd_any(args[0],args[1]);	
	}
	usleep(200000);


}

void usage(char * pn){
	fprintf(stderr,"USAGE : %s [<script file name>]\n",pn);
	fprintf(stderr,"naprimer:\n%s \n%s ./my_script \n",pn,pn);
	fprintf(stderr,"commands:\n");
	fprintf(stderr,"addr <hex addr> # (addr 03fd0000)\n");
	fprintf(stderr,"jump <hex addr> # (jump 03fd0010)\n");
	fprintf(stderr,"loadfile <filename> <hex addr> # (loadfile ./my_file.bin 03fd0000)\n");
	fprintf(stderr,"dumpfile <filename> <hex begin addr> <hex end addr> # (loadfile ./my_file.bin 03fd0000)\n");
	fprintf(stderr,"ack # (ack)\n");

}

int main(int argc, char ** argv)
{
	int t;
	u_init();
	if(argc==2 && !strcmp(argv[1],"--help")){
		usage(argv[0]);
		exit(0);
	}
	phone=u_finddev(0x22b8,0x4903);
	
	if(!phone){
		fprintf(stderr,"phone not found\n");
		return -1;
	}
	
	u_connect();
	script_parse(0);
//	cmd_addr(0x03fd0000);
//	cmd_loadfile("./my_boot.bin",0x03fd0000);
//	cmd_jump(0x3fd0008);
//	ack();
//	unsigned long ret=usb_bulk_write(phoneHandle,1,str,strlen(str),1000);
//	send_packet("test","sssssssssssssssaaaaaaaaaaaaaaaaaaasssssssssssssssssaaasend",strlen("sssssssssssssssaaaaaaaaaaaaaaaaaaasssssssssssssssssaaasend"));
//	fprintf (stderr,"%s\n",usb_strerror());
//	fprintf(stderr,"0x%08x\n",ret);

//	ret=usb_bulk_read(phoneHandle,2,instr,16,500);

//	fprintf (stderr,"%s\n",usb_strerror());
//	fprintf(stderr,"0x%08x\n",ret);
//	fprintf(stderr,"%s\n",instr);
//	fprintf(stderr,"ok");
	
	usb_release_interface(phoneHandle, 0);
	usb_close(phoneHandle);
	usb_free_dev(phone);
/*
	struct usb_device_id generic_device_id;
	generic_device_id.idVendor = vendor;
	generic_device_id.idProduct = product;
	generic_device_id.match_flags = USB_DEVICE_ID_MATCH_VENDOR | USB_DEVICE_ID_MATCH_PRODUCT;
	int ret=usb_serial_bus_register(&generic_device_id);
	printf(stderr, "ret=%i\n");*/
	return -1;
}
